"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transitionCommonPropTypes = exports.propTypes = exports.allowedProps = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 - present Instructure, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

// These props get passed from Transition

// This intersection is needed for calculating allowedProps

// this is getting exported, might be extended later,
// that's why it is separated from BaseTransitionOwnProps

const transitionCommonPropTypes = exports.transitionCommonPropTypes = {
  in: _propTypes.default.bool,
  unmountOnExit: _propTypes.default.bool,
  transitionOnMount: _propTypes.default.bool,
  transitionEnter: _propTypes.default.bool,
  transitionExit: _propTypes.default.bool,
  onTransition: _propTypes.default.func,
  onEnter: _propTypes.default.func,
  onEntering: _propTypes.default.func,
  onEntered: _propTypes.default.func,
  onExit: _propTypes.default.func,
  onExiting: _propTypes.default.func,
  onExited: _propTypes.default.func,
  children: _propTypes.default.node,
  elementRef: _propTypes.default.func
};
const propTypes = exports.propTypes = {
  ...transitionCommonPropTypes,
  enterDelay: _propTypes.default.number,
  exitDelay: _propTypes.default.number,
  transitionClassName: _propTypes.default.string.isRequired,
  exitedClassName: _propTypes.default.string.isRequired,
  exitingClassName: _propTypes.default.string.isRequired,
  enteredClassName: _propTypes.default.string.isRequired,
  enteringClassName: _propTypes.default.string.isRequired,
  className: _propTypes.default.string
};
const allowedProps = exports.allowedProps = ['in', 'unmountOnExit', 'transitionOnMount', 'transitionEnter', 'transitionExit', 'enterDelay', 'exitDelay', 'transitionClassName', 'exitedClassName', 'exitingClassName', 'enteredClassName', 'enteringClassName', 'onTransition', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited', 'children', 'className', 'elementRef'];