import { Component, ReactElement } from 'react';
import type { BaseTransitionProps, BaseTransitionState, BaseTransitionStateValue, BaseTransitionStatesType } from './props';
/**
---
private: true
---
  Note: this is forked from https://github.com/react-bootstrap/react-overlays/blob/master/src/Transition.js
  so that it works with css modules. The internals are pretty different now, but it has roughly the same api.
**/
declare class BaseTransition extends Component<BaseTransitionProps, BaseTransitionState> {
    static propTypes: import("@instructure/shared-types").PropValidators<keyof import("./props").TransitionCommonProps | keyof {
        enterDelay?: number;
        exitDelay?: number;
        transitionClassName: string;
        exitedClassName: string;
        exitingClassName: string;
        enteredClassName: string;
        enteringClassName: string;
        className?: string;
    }>;
    static allowedProps: readonly (keyof import("./props").TransitionCommonProps | keyof {
        enterDelay?: number;
        exitDelay?: number;
        transitionClassName: string;
        exitedClassName: string;
        exitingClassName: string;
        enteredClassName: string;
        enteringClassName: string;
        className?: string;
    })[];
    static defaultProps: {
        in: boolean;
        unmountOnExit: boolean;
        transitionOnMount: boolean;
        transitionEnter: boolean;
        transitionExit: boolean;
        enterDelay: number;
        exitDelay: number;
    };
    static states: Record<BaseTransitionStateValue, BaseTransitionStatesType>;
    _timeouts: ReturnType<typeof setTimeout>[];
    _unmounted: boolean;
    state: {
        transitioning: boolean;
    };
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    componentDidMount(): void;
    getSnapshotBeforeUpdate(prevProps: BaseTransitionProps, prevState: BaseTransitionState): true | null;
    componentDidUpdate(prevProps: BaseTransitionProps, _prevState: BaseTransitionState, cancelPrematurely: boolean): void;
    componentWillUnmount(): void;
    startTransition: (transitionIn: BaseTransitionProps["in"], transitionOnStart: BaseTransitionProps["transitionOnMount"]) => void;
    transition: (toState: BaseTransitionStatesType | null, fromState: BaseTransitionStatesType | null, transitionCallback?: () => void, transitionDuration?: number) => void;
    clearTransition(transitionClassName: string): void;
    enter: (initialState: BaseTransitionStatesType | null) => void;
    exit: (initialState: BaseTransitionStatesType | null) => void;
    transitionEnabled(toState: BaseTransitionStatesType | null): boolean | undefined;
    getTransitionClassName(transitionState: BaseTransitionStatesType | null): string | undefined;
    renderChildren(): ReactElement<any, string | import("react").JSXElementConstructor<any>> | null;
    render(): ReactElement<any, string | import("react").JSXElementConstructor<any>> | null;
}
export default BaseTransition;
export { BaseTransition };
//# sourceMappingURL=index.d.ts.map