import { Component } from 'react';
import type { TransitionProps } from './props';
/**
---
category: components/utilities
---
@module Transition
**/
declare class Transition extends Component<TransitionProps> {
    static readonly componentId = "Transition";
    static allowedProps: readonly (keyof import("./BaseTransition/props").TransitionCommonProps | "type")[];
    static propTypes: import("@instructure/shared-types").PropValidators<keyof import("./BaseTransition/props").TransitionCommonProps | "type">;
    static defaultProps: {
        type: string;
        in: boolean;
        unmountOnExit: boolean;
        transitionOnMount: boolean;
        transitionEnter: boolean;
        transitionExit: boolean;
    };
    static states: Record<import("./BaseTransition/props").BaseTransitionStateValue, import("..").BaseTransitionStatesType>;
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    handleExited: () => void;
    handleEntered: () => void;
    renderTransitionHelper: () => import("@emotion/react/jsx-runtime").JSX.Element;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default Transition;
export { Transition };
//# sourceMappingURL=index.d.ts.map