import PropTypes from 'prop-types';
import type { PropValidators, TransitionTheme } from '@instructure/shared-types';
import type { WithStyleProps, ComponentStyle } from '@instructure/emotion';
import type { TransitionCommonProps, TransitionType } from './BaseTransition/props';
declare const transitionTypePropType: PropTypes.Requireable<TransitionType>;
type OwnProps = {
    type?: TransitionType;
};
type TransitionOwnProps = OwnProps & TransitionCommonProps;
type PropKeys = keyof TransitionOwnProps;
type AllowedPropKeys = Readonly<Array<PropKeys>>;
type TransitionProps = TransitionOwnProps & WithStyleProps<TransitionTheme, TransitionStyle>;
type TransitionStyle = ComponentStyle<'globalStyles'> & {
    duration: TransitionTheme['duration'];
    classNames: {
        transitioning: string;
        exited: string;
        exiting: string;
        entered: string;
        entering: string;
    };
};
declare const propTypes: PropValidators<PropKeys>;
declare const allowedProps: AllowedPropKeys;
export type { TransitionProps, TransitionType, TransitionStyle };
export { propTypes, allowedProps, transitionTypePropType };
//# sourceMappingURL=props.d.ts.map