import type { TransitionTheme } from '@instructure/shared-types';
import type { TransitionProps, TransitionStyle } from './props';
declare const getClassNames: (type: TransitionProps["type"]) => {
    transitioning: string;
    exited: string;
    exiting: string;
    entered: string;
    entering: string;
};
/**
 * ---
 * private: true
 * ---
 * Generates the style object from the theme and provided additional information
 * @param  {Object} componentTheme The theme variable object.
 * @param  {Object} props the props of the component, the style is applied to
 * @param  {Object} state the state of the component, the style is applied to
 * @return {Object} The final style object, which will be used in the component
 */
declare const generateStyle: (componentTheme: TransitionTheme, props: TransitionProps) => TransitionStyle;
export { generateStyle, getClassNames };
export default generateStyle;
//# sourceMappingURL=styles.d.ts.map